{$A+,B-,D+,E+,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
unit crtc;

interface
const
{Color constants }
  Black         = 0;
  Blue          = 1;
  Green         = 2;
  Cyan          = 3;
  Red           = 4;
  Magenta       = 5;
  Brown         = 6;
  LightGray     = 7;
  DarkGray      = 8;
  LightBlue     = 9;
  LightGreen    = 10;
  LightCyan     = 11;
  LightRed      = 12;
  LightMagenta  = 13;
  Yellow        = 14;
  White         = 15;
var
 textattr:byte;
function KeyPressed:boolean;
function ReadKey:char;
procedure Delay(ms:word);
procedure Sound(ms:word);
procedure NoSound;
procedure gotoxy(x,y:byte);
function WhereX:byte;
function WhereY:byte;
procedure clreol;
procedure clrscr;

implementation
var
 scancode:byte;
const
 windmaxx=79;
 windmaxy=24;
procedure clreol;assembler;
asm
  MOV AH,3
  XOR BH,BH
  int 10h
  MOV AX,6*256
  MOV BH,TextAttr
  MOV CX,DX
  MOV DL,WindMaxX
  int 10h
end;

procedure ClrScr; assembler;
asm
 mov ah,0Fh
 int 10h
 xor ah,ah
 int 10h;
end;

function WhereX:byte;assembler;
asm
  MOV	AH,3
  XOR	BH,BH
  int 10h
  MOV  AL,DL
  INC  AL
end;

function WhereY:byte;assembler;
asm
  MOV	AH,3
  XOR	BH,BH
  int 10h
  MOV  AL,DH
  INC  AL
end;

procedure gotoxy(x,y:byte);assembler;
asm
  MOV DL,[x]
  MOV DH,[y]
  DEC DL
  ADD DL,0
  JC  @@1
  CMP DL,windmaxx
  JA  @@1
  DEC DH
  ADD DH,0
  JC  @@1
  CMP DH,windmaxy
  JA  @@1
  MOV AH,2
  XOR BH,BH
  int 10h
@@1:
end;

function KeyPressed:boolean;assembler;
asm
 CMP  ScanCode,0
 JNE  @l1
 MOV  AH,1
 INT  16H
 MOV  AL,0
 JE   @l2
@l1:
 MOV  AL,1
@l2:
end;

function ReadKey:char;assembler;
asm
 MOV  AL,ScanCode
 MOV  ScanCode,0
 OR   AL,AL
 JNE  @l1
 XOR  AH,AH
 INT  16H
 OR   AL,AL
 JNE  @l1
 MOV  ScanCode,AH
 OR   AH,AH
 JNE  @l1
 MOV  AL,'C'-64
@l1:
end;

procedure Delay( ms: Word); assembler;
  asm
    mov ax,1000
    mul [ms]
    mov cx,dx
    mov dx,ax
    mov ax,$8600
    int $15
  end;

procedure Sound(ms:word);assembler;
asm
  mov  bx,[ms]
  MOV  AX,34DDH
  MOV  DX,0012H
  CMP  DX,BX
  JNC  @@2
  DIV  BX
  MOV  BX,AX
  IN   AL,61H
  TEST AL,3
  JNZ  @@1
  OR   AL,3
  OUT  61H,AL
  MOV  AL,0B6H
  OUT  43H,AL
@@1:   MOV	AL,BL
  OUT  42H,AL
  MOV  AL,BH
  OUT  42H,AL
@@2:
end;

procedure NoSound;assembler;
asm
  IN	AL,61H
  AND	AL,0FCH
  OUT	61H,AL
end;

end.